#include "BehaviourShot.h"
#include "Level.h"
#include "LD.h"



BehaviourShot::BehaviourShot( int Speed )
{
  m_DX = 0;
  m_DY = 0;
  m_Speed = Speed;
  
  while ( ( m_DX == 0 )
  &&      ( m_DY == 0 ) )
  {
    m_DX = rand() % 3 - 1;
    m_DY = rand() % 3 - 1;
  }
}



void BehaviourShot::UpdateFixed( Level& Level, GameObject* pObj )
{

  if ( Level.WalkObject( pObj, m_Speed * m_DX, m_Speed * m_DY ) )
  {
    pObj->m_RemoveMe = true;
  }

}



void BehaviourShot::OnEvent( Level& Level, const std::string& Event, GameObject* pObj, GameObject* pOtherObject )
{

  if ( Event == "Move.R" )
  {
    m_DX = 1;
    m_DY = 0;
  }
  else if ( Event == "Move.L" )
  {
    m_DX = -1;
    m_DY = 0;
  }
  else if ( Event == "Move.U" )
  {
    m_DX = 0;
    m_DY = -1;
  }
  else if ( Event == "Move.D" )
  {
    m_DX = 0;
    m_DY = 1;
  }
  else if ( Event == "Move.UL" )
  {
    m_DX = -1;
    m_DY = -1;
  }
  else if ( Event == "Move.UR" )
  {
    m_DX = 1;
    m_DY = -1;
  }
  else if ( Event == "Move.DL" )
  {
    m_DX = -1;
    m_DY = 1;
  }
  else if ( Event == "Move.DR" )
  {
    m_DX = 1;
    m_DY = 1;
  }

}

