#pragma once

#include "LDTypes.h"

#include <windows.h>
#include <list>


class Level;
class Behaviour;

class GameObject
{

  public:

    float                     m_XFract;
    float                     m_YFract;

    int                       m_X;
    int                       m_Y;

    bool                      m_RemoveMe;
    bool                      m_Rotateable;

    float                     m_Angle;

    int                       m_ID;

    LD::TextureTypes          m_TexSection;

    LD::ObjectType            m_Type;

    RECT                      m_Bounds;

    POINT                     m_DisplayOffset;

    std::list<Behaviour*>     m_Behaviour;

    DWORD                     m_Color;



    GameObject( int X, int Y, LD::ObjectType Type );
    ~GameObject();


    void                      Display( Level& Level );
    void                      Update( float ElapsedTime, Level& Level );
    void                      UpdateFixed( Level& Level );

    RECT                      Bounds();

    void                      OnEvent( Level& Level, const std::string& Event, GameObject* pObj, GameObject* pOtherObject );


};
